function npivtest3 = npivtest3(grade, subject)

tic

% Legendre-type polynomials for L^2[0,1], scaled to be orthogonal on [0,1] by the shift 2x - 1
	adjust = @(x)2*x-1;
	psi0 = @(x)1;
	psi1 = @(x)sqrt(3)*adjust(x);
	psi2 = @(x)sqrt(5)*1/2*(3*adjust(x)^2-1);
	psi3 = @(x)sqrt(7)*1/2*(5*adjust(x)^3-3*adjust(x));
	psi4 = @(x)sqrt(9)*1/8*(35*adjust(x)^4-30*adjust(x)^2+3);
	psi5 = @(x)sqrt(11)*1/8*(63*adjust(x)^5-70*adjust(x)^3+15*adjust(x));
	psi6 = @(x)sqrt(13)*1/16*(231*adjust(x)^6 - 315*adjust(x)^4 + 105*adjust(x)^2 - 5);
	psi7 = @(x)sqrt(15)*1/16*(429*adjust(x)^7 - 693*adjust(x)^5 + 315*adjust(x)^3 - 35*adjust(x));
	
% Legendre-type polynomials for L^2[0,1]^3, from the above.
	f1 = @(x)psi0(x(1))*psi0(x(2))*psi0(x(3));
	
	f2 = @(x)psi1(x(1))*psi0(x(2))*psi0(x(3));
	f3 = @(x)psi0(x(1))*psi1(x(2))*psi0(x(3));
	f4 = @(x)psi0(x(1))*psi1(x(2))*psi1(x(3));
	
	f5 = @(x)psi1(x(1))*psi1(x(2))*psi0(x(3));
	f6 = @(x)psi1(x(1))*psi0(x(2))*psi1(x(3));
	f7 = @(x)psi0(x(1))*psi1(x(2))*psi1(x(3));
	f8 = @(x)psi2(x(1))*psi0(x(2))*psi0(x(3));
	f9 = @(x)psi0(x(1))*psi2(x(2))*psi0(x(3));
	f10 = @(x)psi0(x(1))*psi0(x(2))*psi2(x(3));
	
	f11 = @(x)psi1(x(1))*psi1(x(2))*psi1(x(3));
	f12 = @(x)psi2(x(1))*psi1(x(2))*psi0(x(3));
	f13 = @(x)psi2(x(1))*psi0(x(2))*psi1(x(3));
	f14 = @(x)psi0(x(1))*psi2(x(2))*psi1(x(3));
	f15 = @(x)psi1(x(1))*psi2(x(2))*psi0(x(3));
	f16 = @(x)psi0(x(1))*psi1(x(2))*psi2(x(3));
	f17 = @(x)psi1(x(1))*psi0(x(2))*psi2(x(3));
	f18 = @(x)psi3(x(1))*psi0(x(2))*psi0(x(3));
	f19 = @(x)psi0(x(1))*psi3(x(2))*psi0(x(3));
	f20 = @(x)psi0(x(1))*psi0(x(2))*psi3(x(3));
	
	f21 = @(x)psi1(x(1))*psi1(x(2))*psi2(x(3));
	f22 = @(x)psi1(x(1))*psi2(x(2))*psi1(x(3));
	f23 = @(x)psi2(x(1))*psi1(x(2))*psi1(x(3));
	f24 = @(x)psi3(x(1))*psi1(x(2))*psi0(x(3));
	f25 = @(x)psi3(x(1))*psi0(x(2))*psi1(x(3));
	f26 = @(x)psi1(x(1))*psi3(x(2))*psi0(x(3));
	f27 = @(x)psi0(x(1))*psi3(x(2))*psi1(x(3));
	f28 = @(x)psi0(x(1))*psi1(x(2))*psi3(x(3));
	f29 = @(x)psi1(x(1))*psi0(x(2))*psi3(x(3));
	f30 = @(x)psi4(x(1))*psi0(x(2))*psi0(x(3));
	f31 = @(x)psi0(x(1))*psi4(x(2))*psi0(x(3));
	f32 = @(x)psi0(x(1))*psi0(x(2))*psi4(x(3));
	f33 = @(x)psi2(x(1))*psi2(x(2))*psi0(x(3));
	f34 = @(x)psi2(x(1))*psi0(x(2))*psi2(x(3));
	f35 = @(x)psi0(x(1))*psi2(x(2))*psi2(x(3));
	
	phij = cell(35,1);
	phij(1) = {f1};
	phij(2) = {f2};
	phij(3) = {f3};
	phij(4) = {f4};
	phij(5) = {f5};
	phij(6) = {f6};
	phij(7) = {f7};
	phij(8) = {f8};
	phij(9) = {f9};
	phij(10) = {f10};
	phij(11) = {f11};
	phij(12) = {f12};
	phij(13) = {f13};
	phij(14) = {f14};
	phij(15) = {f15};
	phij(16) = {f16};
	phij(17) = {f17};
	phij(18) = {f18};
	phij(19) = {f19};
	phij(20) = {f20};
	phij(21) = {f21};
	phij(22) = {f22};
	phij(23) = {f23};
	phij(24) = {f24};
	phij(25) = {f25};
	phij(26) = {f26};
	phij(27) = {f27};
	phij(28) = {f28};
	phij(29) = {f29};
	phij(30) = {f30};
	phij(31) = {f31};
	phij(32) = {f32};
	phij(33) = {f33};
	phij(34) = {f34};
	phij(35) = {f35};
	
% kernel

	kernfn = @(x)normpdf(x,0,1);
	theta = .8; % parameters for the integral operator
	C = .2; % parameters for the integral operator

% load the data and normalize the covariates

	iquad = 0; % iquad -1 tests null hypothesis of no effect, 0 tests null hypothesis of linearity, and 1 tests null hypothesis of quadratic relation
	L = 35;


	
	if grade == 1 & subject == 2
		M = dlmread('fourthdata2.txt', '\t', 1, 0);
	end;
	
	n = size(M,1)

	x = M(:,2); 
	if subject == 1
		y = M(:,3);
	end;
	if subject == 2
		y = M(:,4);
	end;
	z1 = M(:,5);
	z2 = M(:,1);
	w = M(:,6);

	x = (x - min(x))./(max(x) - min(x));
	w = (w - min(w))./(max(w) - min(w));
	z1 = (z1 - min(z1))./(max(z1) - min(z1));
	z2 = (z2 - min(z2))./(max(z2) - min(z2));

	xx = [ones(n,1) x z1 z2];
	ww = [ones(n,1) w z1 z2];

	if (iquad == 1)

		x2 = x.^2;
		w2 = w.^2;

		xx = [ones(n,1) x x2 z1 z2];
		ww = [ones(n,1) w w2 z1 z2];

	end
	
	if (iquad == -1)

		xx = [ones(n,1) z1 z2];
		ww = [ones(n,1) z1 z2];
	
	end

% estimate the model using 2SLS

	thetahat = inv(ww'*xx)*ww'*y;
	gvec = y - xx*thetahat;

% estimate the density of xzw at various points in [0,1]

	s11 = std(z1);
	s12 = std(z2);
	s2 = std(w);
	s3 = std(x);
	
	h11 = 1.059 * 1 / n^0.2 * s11;
	h12 = 1.059 * 1 / n^0.2 * s12;
	h2 = 1.059 * 1 / n^0.2 * s2;
	h3 = 1.059 * 1 / n^0.2 * s3;
	
	intsup = seqa(.1,.1, 10);

	prez1(1:n,1:n) = [0];
	prez2(1:n,1:n) = [0];
	prew(1:n,1:n) = [0];
	for i=1:n,
		for j=1:n,
			prez1(i,j) = kernfn((z1(j)-z1(i))/h11);
			prez2(i,j) = kernfn((z2(j)-z2(i))/h12);
			prew(i,j) = kernfn((w(j)-w(i))/h2);
		end;
		
		if (mod(i,20) == 0)
			i
		end;
	end;

	prex(1:size(intsup,1),1:n) = [0];
	for k=1:size(intsup,1),
		for j=1:n,
			prex(k,j) = kernfn((x(j)-intsup(k))/h3);
		end;
	end;
	
	
	fxzw(1:n,1:size(intsup,1)) = [0];
	for i=1:n,
		for j=1:n,
			for k=1:size(intsup,1),
				if i ~= j
					fxzw(i,k) = fxzw(i,k) + prez1(i,j)*prez2(i,j)*prew(i,j)*prex(k,j);
				end;
			end;
		end;
		
		if (mod(i,20) == 0)
			i
		end;
	end;

	fxzw = fxzw ./ (n * h11 * h12 * h2 * h3);

% compute the kernel of the integral operator at various points in [0,1]

	lk(1:n,1:size(intsup,1),1:size(intsup,1)) = [0];
	for i=1:n,
		for k=1:size(intsup,1),
			for l=1:size(intsup,1),
				lk(i,k,l) = intop2([z1(i) z2(i) intsup(k) intsup(l)],theta,C);
			end;
		end;
	end;
	
% compute the S matrix, the element-wise square of that matrix and use that to integrate to get the test statistic

	S(1:size(intsup,1),1:size(intsup,1),1:size(intsup,1)) = [0];
	for k=1:size(intsup,1),
		for l=1:size(intsup,1),
			for m=1:size(intsup,1),
				for i=1:n,
					S(k,l,m) = S(k,l,m) + gvec(i)*fxzw(i,k)*lk(i,l,m);
				end;
			end;
		end;
	end;

	S = S ./ sqrt(n);
	S2 = S.^2;

	teststat = sum(sum(sum(S2)))*.1^3;

% compute the script-Y matrix

	s11 = std(z1);
	s12 = std(z2);
	s2 = std(w);

	h11 = 1.059 * 1 / n^0.2 * s11;
	h12 = 1.059 * 1 / n^0.2 * s12;
	h2 = 1.059 * 1 / n^0.2 * s2;

	kernest1(1:n) = 0;
	kernest2(1:n) = 0;
	for i=1:n,
		for j=1:n,
			if i ~= j
				kernest1(i) = kernest1(i) + kernfn((z1(j)-z1(i))/h11)*kernfn((z2(j)-z2(i))/h12)*kernfn((w(j)-w(i))/h2)*(y(j)-xx(j,:)*thetahat);
				kernest2(i) = kernest2(i) + kernfn((z1(j)-z1(i))/h11)*kernfn((z2(j)-z2(i))/h12)*kernfn((w(j)-w(i))/h2);
			end;
		end;
		
		if (mod(i,20) == 0)
			i
		end;
	end;

	uhat = y - xx * thetahat - kernest1' ./ kernest2';
	
	sY = diag(uhat.^2);

% compute the Phi matrix

	Phi(1:L,1:n) = [0];
	for j=1:L,
		for k=1:n,
			Phi(j,k) = phij{j}([z1(k) z2(k) w(k)]);
		end;
	end;
	
% compute the D matrix
	
	s11 = std(z1);
	s12 = std(z2);
	s2 = std(w);
	s3 = std(x);
	
	h11 = 1.059 * 1 / n^0.2 * s11;
	h12 = 1.059 * 1 / n^0.2 * s12;
	h2 = 1.059 * 1 / n^0.2 * s2;
	h3 = 1.059 * 1 / n^0.2 * s3;
	
	% precompute some values and then compute the density estimates

		clear prex;
		prex(1:n,1:size(intsup,1)) = [0];
		for j=1:n,
			for xi = 1:size(intsup,1),
				prex(j,xi) = kernfn((x(j)-intsup(xi))/h3);
			end;
		end;

		clear prew;
		prew(1:n,1:size(intsup,1)) = [0];
		for j=1:n,
			for wl = 1:size(intsup,1),
				prew(j,wl) = kernfn((w(j)-intsup(wl))/h2);
			end;
		end;

		clear prez1;
		prez1(1:n,1:size(intsup,1)) = [0];
		for j=1:n,
			for z11j = 1:size(intsup,1),
				prez1(j,z11j) = kernfn((z1(j)-intsup(z11j))/h11);
			end;
		end;
		
		
		clear prez2;
		prez2(1:n,1:size(intsup,1)) = [0];
		for j=1:n,
			for z12j = 1:size(intsup,1),
				prez2(j,z12j) = kernfn((z2(j)-intsup(z12j))/h12);
			end;
		end;

		fxzw2(1:size(intsup,1),1:size(intsup,1),1:size(intsup,1),1:size(intsup,1)) = [0];
		for xi=1:size(intsup,1),
			for z11j=1:size(intsup,1),
				for z12j=1:size(intsup,1),
					for wl=1:size(intsup,1),
						for j=1:n,
							fxzw2(xi,z11j,z12j,wl) = fxzw2(xi,z11j,z12j,wl) + prez1(j,z11j)*prez2(j,z12j)*prew(j,wl)*prex(j,xi);
						end;
					end;
				end;
			end;

			xi
		end;

		fxzw2 = fxzw2 ./ (n * h11 * h12 * h2 * h3);

	% precompute some values and then compute D

		preintop(1:size(intsup,1),1:size(intsup,1),1:size(intsup,1),1:size(intsup,1)) = [0];
		for z11j=1:size(intsup,1),
			for z21k=1:size(intsup,1),
				for z12j=1:size(intsup,1),
					for z22k=1:size(intsup,1),
						preintop(z11j,z21k,z12j,z22k) = intop2([intsup(z11j) intsup(z21k) intsup(z12j) intsup(z22k)],theta,C);
					end;
				end;
			end;
		end;

		prephi1(1:L,1:size(intsup,1),1:size(intsup,1),1:size(intsup,1)) = [0];
		for j=1:L,
			for xi=1:size(intsup,1),
				for z11j=1:size(intsup,1),
					for z12j=1:size(intsup,1),
						prephi1(j,xi,z11j,z12j) = phij{j}([intsup(xi) intsup(z11j) intsup(z12j)]);
					end;
				end;
			end;
		end;

		prephi2(1:L,1:size(intsup,1),1:size(intsup,1),1:size(intsup,1)) = [0];
		for k=1:L,
			for z2k=1:size(intsup,1),
				for wl1=1:size(intsup,1),
					for wl2=1:size(intsup,1),
						prephi2(k,z2k,wl1,wl2) = phij{k}([intsup(z2k) intsup(wl1) intsup(wl2)]);
					end;
				end;
			end;
		end;


		dintegrand(1:size(intsup,1),1:size(intsup,1),1:size(intsup,1),1:size(intsup,1),1:size(intsup,1),1:size(intsup,1)) = [0];
		Djk(1:L,1:L) = [0];
		for j=1:L,
			for k=1:L,

				dintegrand(1:size(intsup,1),1:size(intsup,1),1:size(intsup,1),1:size(intsup,1),1:size(intsup,1),1:size(intsup,1)) = [0];

				for xi=1:size(intsup,1),
					for z11j=1:size(intsup,1),
						for z12j=1:size(intsup,1),
							for z21k=1:size(intsup,1),
								for z22k=1:size(intsup,1),
									for wl=1:size(intsup,1),
										dintegrand(xi,z11j,z12j,z21k,z22k,wl) = fxzw2(xi,z11j,z12j,wl)*preintop(z11j,z12j,z21k,z22k)*prephi1(j,xi,z11j,z12j)*prephi2(k,z21k,z22k,wl);
									end;
								end;
							end;
						end;
					end;
				end;

				Djk(j,k) = sum(sum(sum(sum(sum(sum(dintegrand))))))*.1^6;

			end;

			j
		end;

% compute the M matrix

	if iquad == 0
		for i=1:n,
			wtilde(:,i) = [1 w(i) z1(i) z2(i)]';
			dhat(1:4,1:4) = [0];
		end;
	end;
	
	if iquad == 1
		for i=1:n,
			wtilde(:,i) = [1 w(i) w(i).^2 z1(i) z2(i)]';
			dhat(1:5,1:5) = [0];
		end;
	end;
	
	if iquad == -1
		for i=1:n,
			wtilde(:,i) = [1 z1(i) z2(i)]';
			dhat(1:3,1:3) = [0];
		end;
	end;

	ghattheta = xx;
	for i=1:n,
		dhat = dhat + wtilde(:,i)*ghattheta(i,:); 	
	end;
	dhat = dhat / n;
	
	if iquad == 0
		gammahat = inv(dhat'*eye(4)*dhat)*dhat'*eye(4);
	end;
	
	if iquad == 1
		gammahat = inv(dhat'*eye(5)*dhat)*dhat'*eye(5);
	end;
	
	if iquad == -1
		gammahat = inv(dhat'*eye(3)*dhat)*dhat'*eye(3);
	end;

	M = eye(n) - 1/n * ghattheta * gammahat * wtilde;
	
% get the approximate eigenvalues of thetahat

	eigenvals = eig(1/n*Djk*Phi*M*sY*M'*Phi'*Djk');
	eigenvals = sort(eigenvals,'descend');
	eigenvals = real(eigenvals);
	
% estimate the critical value

	omegatilde = eigenvals(1:10);
	randn('state', 2008);

	simlength = 1000000;
	critvaldraw(1:simlength) = [0];
	for i=1:simlength,
		chisquare = randn(size(omegatilde,1),1);
		chisquare = chisquare.^2;
		critvaldraw(i) = omegatilde' * chisquare;
		
		if (mod(i,simlength/10) == 0)
			i
		end;
	end;

	critvaldraw = sort(critvaldraw,'descend');
	criticalvalue = critvaldraw(simlength*.05);
	
	rejectnull = 0;
		
	if (teststat > criticalvalue)
		rejectnull = 1;
	end;

	fprintf(1, 'Test statistic:  %6.3f \n', teststat)
	fprintf(1, 'Critical value:  %6.3f \n', criticalvalue)
	fprintf(1, 'Reject null?:  %1.0f \n', rejectnull)

toc
